template <class T>
class DNode
{
	private:
		//       
		DNode<T> *prev, *next;
	public:
		T data;
		//
		DNode(const T& item,
        	  DNode<T> *ptrprev = NULL,
      	  DNode<T> *ptrnext = NULL):
					data(item), prev(ptrprev),next(ptrnext)
               {
               	if (prev) prev->next = this;
                  if (next) next->prev = this;
               }
		//    
      void InsertBefor(DNode<T> *p);
		void InsertAfter(DNode<T> *p);
		//    
		DNode<T> *DeleteBefor(void);
  		DNode<T> *DeleteAfter(void);
		//     
		DNode<T> *PrevNode(void) const {return prev;}
		DNode<T> *NextNode(void) const {return next;}
};

template <class T>
void PrintDNodeList(DNode<T> * head)
{
   if (!head) {cout <<"\nList empty"; return;}
   cout << '\n';
   while (head)
   {
   	cout << head->data << '\t';
      head = head->NextNode();
   }
}


