class PQueue
{
	private:
		//  
		PQDataType pqlist[MaxPQSize];
		//   
		int count;
	public:
		// 
		PQueue(void): count(0){}
		//   ,   ,  
		void PQInsert (const PQDataType& item);
		PQDataType PQDelete(void);
		void ClearPQ(void) {count = 0;}

		//  ?, ?
		int PQEmpty(void) const {return !count;}
		int PQFull(void) const {return count == MaxPQSize;}
		//   
		int PQLength(void) const {return count;}
};

void PQueue::PQInsert(const PQDataType& item)
{
	//   ,   
	if (count == MaxPQSize)
	{
		cerr << "PQueue full!" << endl;
		exit(1);
	}
	//       count  
	pqlist[count] = item;
	count++;
}
PQDataType PQueue::PQDelete(void)
{
	PQDataType min;
	int i, minindex =0;

	if (count > 0)
	{
		//        
		min = pqlist[0]; // ,  pqlist[0] - 
		//   ,     
		for (i=1;i<count; i++)
			if (pqlist[i]< min)
			{
				min = pqlist[i];
				minindex = i;
			}
		//      
		//     count
		pqlist[minindex] = pqlist[count-1];
		count--;
	}
	else
	//  pqlist ,  
	{
		cerr << "PQueue empty!" << endl;
		exit(1);
	}
	//  
	return min;
}

