template <class T>
class Node
{
	private:
		//     
		Node<T> *next;
	public:
		T data;
		//
		Node(const T& item, Node<T> *ptrnext = NULL):
					data(item), next(ptrnext) {return;}
		//  
		void InsertAfter(Node<T> *p)
		{
			p->next = next;
			next = p;
		}
		//  
		Node<T> *DeleteAfter(void);
		//   
		Node<T> *NextNode(void) const {return next;}
};

template <class T>
Node<T>* Node<T>::DeleteAfter(void)
{
	//     NULL
	if (next==NULL) return NULL;
	//    
	Node<T> *tempPtr = next;
	//    ,   
	next = tempPtr->next;
	//     
	return tempPtr;
}

template <class T>
void PrintNodeList(Node<T> * head)
{
   if (!head) {cout <<"\nList empty"; return;}
   cout << '\n';
   while (head)
   {
   	cout << head->data << '\t';
      head = head->NextNode();
   }
}

template <class T>
Node<T> *BuildNodeList(T M[], int n)
{
	Node<T> *head=NULL;
   for (int i = n-1; i>=0; i--)
   	head= new Node<T>(M[i],head);
   return head;
}

