class Queue
{
	private:
		//  
		QDataType qlist[MaxQSize];
		//   ,      
		// 
		int front, rear, count;
	public:
		//  
		Queue(void): front(0), rear(0), count(0){}
		//   ,   ,  
		void QInsert (const QDataType& item);
		QDataType QDelete(void);
		void ClearQueue(void) { front = 0; rear = 0; count = 0;}
		//      
		QDataType QFront(void) const;
		//  ?, ?
		int QEmpty(void) const {return !count;}
		int QFull(void) const {return count == MaxQSize;}
		//   
		int QLength(void) const {return count;}
};
void Queue::QInsert(const QDataType& item)
{
	//   ,   
	if (count == MaxQSize)
	{
		cerr << "Queue full!" << endl;
		exit(1);
	}
	//  count   item  Qlist
	count++;
	qlist[rear] = item;
	rear = (rear+1)%MaxQSize;
}
QDataType Queue::QDelete(void)
{
	QDataType temp;
	//   ,   
	if (!count)
	{
		cerr << "Queue empty!" << endl;
		exit(1);
	}

	//     
	temp = qlist[front];
	//  count    
	count--;
	front = (front+1)%MaxQSize;
	//  
	return temp;
}
QDataType Queue::QFront(void) const
{
	//   ,   
	if (!count)
	{
		cerr << "Queue empty!" << endl;
		exit(1);
	}
	//  
	return qlist[front];
}
